diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/ChangeLog gcc-2.95.3/gcc/ChangeLog
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/ChangeLog	Fri Mar 16 06:52:02 2001
+++ gcc-2.95.3/gcc/ChangeLog	Fri Jun 22 10:51:46 2001
@@ -1,3 +1,45 @@
+2000-10-30	Joel Sherrill <joel@OARcorp.com>
+
+	* configure.in: (mips*-rtems*): New target.
+	* config/mips/rtems.h: New file.
+	* configure: Regenerated.
+
+2000-09-21	Joel Sherrill <joel@OARcorp.com>
+
+	* configure.in (a29k-*-rtems*): New target.
+	* config/a29k/rtems.h: New file.
+	* configure: Regenerated.
+
+2000-08-28	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* config/i386/rtems.h, config/i386/rtemself.h,
+	config/i386/t-rtems-i386: Set CC1_SPEC and CPP_SPEC properly.
+	Ensure _SOFT_FLOAT is set when using soft floating point.
+	Adds multilibs to i386-rtems.
+
+2000-06-09  Kazu Hirata  <kazu@hxi.com>
+
+	* config/h8300/lib1funcs.asm: Declare the machine architecture at
+	the beginning of the file.
+
+Thu Jul 13 11:21:50 CDT 2000 Joel Sherrill (joel@OARcorp.com)
+
+	* i386/t-i386bare: Added crtend.o and crtbegin.o as 
+	MULTILIB_EXTRA_PARTS.
+	* i386/t-rtems-i386: Added crtend.o and crtbegin.o as 
+	MULTILIB_EXTRA_PARTS.
+	* sparc/t-elf: Added crtend.o and crtbegin.o as MULTILIB_EXTRA_PARTS.
+	* m68k/t-m68kelf: Added crtend.o and crtbegin.o as MULTILIB_EXTRA_PARTS.
+
+Tue Jul 11 07:42:27 CDT 2000 Joel Sherrill (joel@OARcorp.com)
+
+	* i386/t-i386bare: Add multilib support with soft float support.
+	* i386/t-rtems-i386: Add multilib support with soft float support.
+
+Tue Jul 11 07:42:27 CDT 2000 Joel Sherrill (joel@OARcorp.com)
+
+	* i960/i960.h: Define _SOFT_FLOAT when -msoft-float selected.
+
 Fri Mar 16 12:46:19 GMT 2001 Bernd Schmidt  (bernds@redhat.com)
 
 	* gcc-2.95.3 Released.
@@ -1018,6 +1060,17 @@
 	* gcc.texi: Use terms "GNU Compiler Collection" and "GCC".
 	Also update copyright.
 
+ Wed Jul 28 09:14:33 CDT 1999  Joel Sherrill <joel@OARcorp.com>
+
+	* configure.in (m68k-*-rtemscoff*): Added.
+	* configure.in (mips64orion-*-rtems*): Converted to ELF.
+	* configure.in (sparc-*-rtemsaout*): Added as alias for old
+	  sparc-rtems configuration.
+	* configure.in (sparc-*-rtemself*): Added.
+	* configure.in (sparc-*-rtems*): Now ELF not a.out.
+	* config/i386/rtems.h: Added comment.
+	* config/sparc/rtemself.h: New file.
+
 Wed Jul 28 21:39:31 PDT 1999 Jeff Law  (law@cygnus.com)
 
 	* gcc-2.95 Released.
@@ -1085,6 +1138,16 @@
 	* configure: Rebuilt.
 	* alpha/t-ieee: New file.
 
+Tue Jul 13 20:57:02 1999  Charles-Antoine Gauthier <charles.gauthier@iit.nrc.ca>
+
+	* configure.in (m68k-rtemself): Added.
+	* config/elfos.h: Added ifndef wrapper for DWARF2_DEBUGGING_INFO
+	  and DWARF_DEBUGGING_INFO.
+	* config/m68k/crti.s: New file.
+	* config/m68k/crtn.s: New file.
+	* config/m68k/t-crtstuff: New file.
+	* config/m68k/rtemself.h: New file.
+
 Tue Jul 13 10:44:14 1999  Jeffrey A Law  (law@cygnus.com)
 
 	Wed Jun 16 20:29:00 1999  J"orn Rennecke <amylaar@cygnus.co.uk>
@@ -2100,6 +2163,15 @@
 
 	* fixinc/hackshell.tpl: Fix mis-applied patch.
 	* fixinc/inclhack.sh: Regenerated.
+
+Fri May 14 09:28:07 CDT 1999  Rosimildo DaSilva <rdasilva@connecttel.com>
+
+      * configure.in (i[[34567]]86-*-rtemself*): Now uses crtstuff for
+        global ctor/dtor and C++ exception handling.
+      * config/i386/rtemself.h: Now uses crtstuff (crti.o + crtbegin.o)
+        for STARTFILE_SPEC and crtstuff (crtend.o + crtn.o) for
+        ENDFILE_SPEC.
+      * config/i386/t-rtems-i386: New File.
 
 Thu May 13 21:05:55 1999  Mark Kettenis  <kettenis@gnu.org>
 
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/a29k/rtems.h gcc-2.95.3/gcc/config/a29k/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/a29k/rtems.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/a29k/rtems.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,36 @@
+/* Definitions for rtems targeting a AMD A29K using COFF.
+   Copyright (C) 1997, 1998 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "a29k/a29k.h"
+
+/* Specify predefined symbols in preprocessor.  */
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-D_AM29K -D_AM29000 -D_EPI -Drtems -D__rtems__ \
+  -Asystem(rtems) -Acpu(a29k) -Amachine(a29k)"
+
+/* Generate calls to memcpy, memcmp and memset.  */
+#ifndef TARGET_MEM_FUNCTIONS
+#define TARGET_MEM_FUNCTIONS
+#endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/arm/rtems-elf.h gcc-2.95.3/gcc/config/arm/rtems-elf.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/arm/rtems-elf.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/arm/rtems-elf.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,37 @@
+/* Definitions for RTEMS based ARM systems using ELF
+   Copyright (C) 2000 Free Software Foundation, Inc.
+ 
+This file is part of GNU CC.
+ 
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+ 
+You should have received a copy of the GNU General Public License
+along with this program; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* Run-time Target Specification.  */
+#define TARGET_VERSION  fputs (" (ARM/ELF RTEMS)", stderr);
+
+#define HAS_INIT_SECTION
+
+#include "unknown-elf.h"
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-Darm -Darm_elf -Drtems -D__rtems__ -D__ELF__ \
+   -Asystem(rtems) -Acpu(arm) -Amachine(arm)"
+
+/*#undef INVOKE_main*/
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
+
+
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/c4x/rtems.h gcc-2.95.3/gcc/config/c4x/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/c4x/rtems.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/c4x/rtems.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,37 @@
+/* Definitions of RTEMS executing on an TMS320C[34]x using coff
+   Copyright (C) 1996, 1997, 1999 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "c4x/c4x.h"
+
+/* Specify predefined symbols in preprocessor.  */
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-D__rtems__ -Asystem(rtems)"
+
+/* Generate calls to memcpy, memcmp and memset.  */
+#ifndef TARGET_MEM_FUNCTIONS
+#define TARGET_MEM_FUNCTIONS
+#endif
+
+/* Include machine independent RTEMS configuration parameters.  */
+#include <rtems.h>
+
+/* End of c4x/rtems.h.  */
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/elfos.h gcc-2.95.3/gcc/config/elfos.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/elfos.h	Tue Apr 11 20:22:51 2000
+++ gcc-2.95.3/gcc/config/elfos.h	Fri Jun 22 10:49:58 2001
@@ -69,11 +69,15 @@
 
 /* System V Release 4 uses DWARF debugging info.  */
 
-#define DWARF_DEBUGGING_INFO
+#ifndef DWARF_DEBUGGING_INFO
+#define DWARF_DEBUGGING_INFO 1
+#endif
 
 /* All ELF targets can support DWARF-2.  */
 
-#define DWARF2_DEBUGGING_INFO
+#ifndef DWARF2_DEBUGGING_INFO
+#define DWARF2_DEBUGGING_INFO 1
+#endif
 
 /* Also allow them to support STABS debugging.  */
 
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/h8300/lib1funcs.asm gcc-2.95.3/gcc/config/h8300/lib1funcs.asm
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/h8300/lib1funcs.asm	Wed Dec 16 15:02:55 1998
+++ gcc-2.95.3/gcc/config/h8300/lib1funcs.asm	Fri Jun 22 10:49:58 2001
@@ -101,6 +101,14 @@
 #define A3E	e3
 #endif
 
+#ifdef __H8300H__
+	.h8300h
+#endif
+
+#ifdef __H8300S__
+	.h8300s
+#endif
+
 #ifdef L_cmpsi2
 #ifdef __H8300__
 	.section .text
@@ -310,14 +318,6 @@
 ;; We bunch all of this into one object file since there are several
 ;; "supporting routines".
 
-#ifdef __H8300H__
-	.h8300h
-#endif
-
-#ifdef __H8300S__
-	.h8300s
-#endif
-
 	.section .text
 	.align 2
 
@@ -741,14 +741,6 @@
 	rts
 
 #else /* __H8300H__ */
-
-#ifdef __H8300H__
-	.h8300h
-#endif
-
-#ifdef __H8300S__
-	.h8300s
-#endif
 
 	.global	___mulsi3
 ___mulsi3:
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/h8300/rtems.h gcc-2.95.3/gcc/config/h8300/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/h8300/rtems.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/h8300/rtems.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,37 @@
+/* Definitions for rtems targeting a H8
+   Copyright (C) 1996, 1997 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "h8300/h8300.h"
+
+/* Specify predefined symbols in preprocessor.  */
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-Dh8300 \
+  -D__LONG_MAX__=2147483647L -D__LONG_LONG_MAX__=2147483647L \
+  -Drtems -D__rtems__ -Asystem(rtems) -Acpu(h8300) -Amachine(h8300)"
+
+/* Generate calls to memcpy, memcmp and memset.  */
+#ifndef TARGET_MEM_FUNCTIONS
+#define TARGET_MEM_FUNCTIONS
+#endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/i386elf.h gcc-2.95.3/gcc/config/i386/i386elf.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/i386elf.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/i386/i386elf.h	Fri Jun 22 13:58:50 2001
@@ -0,0 +1,175 @@
+/* Definitions for Intel 386 running ELF format.
+   Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
+   Contributed by Eric Youngdale.
+   Modified for stabs-in-ELF by H.J. Lu.
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#define LINUX_DEFAULT_ELF
+
+/* A lie, I guess, but the general idea behind linux/ELF is that we are
+   supposed to be outputting something that will assemble under SVr4.
+   This gets us pretty close.  */
+#include <i386/i386.h>	/* Base i386 target machine definitions */
+#include <i386/att.h>	/* Use the i386 AT&T assembler syntax */
+#include <linux.h>	/* some common stuff */
+
+#undef TARGET_VERSION
+#define TARGET_VERSION fprintf (stderr, " (i386 RTEMS with ELF)");
+
+/* The svr4 ABI for the i386 says that records and unions are returned
+   in memory.  */
+#undef DEFAULT_PCC_STRUCT_RETURN
+#define DEFAULT_PCC_STRUCT_RETURN 1
+
+/* This is how to output an element of a case-vector that is relative.
+   This is only used for PIC code.  See comments by the `casesi' insn in
+   i386.md for an explanation of the expression this outputs. */
+#undef ASM_OUTPUT_ADDR_DIFF_ELT
+#define ASM_OUTPUT_ADDR_DIFF_ELT(FILE, BODY, VALUE, REL) \
+  fprintf (FILE, "\t.long _GLOBAL_OFFSET_TABLE_+[.-%s%d]\n", LPREFIX, VALUE)
+
+/* Indicate that jump tables go in the text section.  This is
+   necessary when compiling PIC code.  */
+#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)
+
+/* Copy this from the svr4 specifications... */
+/* Define the register numbers to be used in Dwarf debugging information.
+   The SVR4 reference port C compiler uses the following register numbers
+   in its Dwarf output code:
+	0 for %eax (gnu regno = 0)
+	1 for %ecx (gnu regno = 2)
+	2 for %edx (gnu regno = 1)
+	3 for %ebx (gnu regno = 3)
+	4 for %esp (gnu regno = 7)
+	5 for %ebp (gnu regno = 6)
+	6 for %esi (gnu regno = 4)
+	7 for %edi (gnu regno = 5)
+   The following three DWARF register numbers are never generated by
+   the SVR4 C compiler or by the GNU compilers, but SDB on x86/svr4
+   believes these numbers have these meanings.
+	8  for %eip    (no gnu equivalent)
+	9  for %eflags (no gnu equivalent)
+	10 for %trapno (no gnu equivalent)
+   It is not at all clear how we should number the FP stack registers
+   for the x86 architecture.  If the version of SDB on x86/svr4 were
+   a bit less brain dead with respect to floating-point then we would
+   have a precedent to follow with respect to DWARF register numbers
+   for x86 FP registers, but the SDB on x86/svr4 is so completely
+   broken with respect to FP registers that it is hardly worth thinking
+   of it as something to strive for compatibility with.
+   The version of x86/svr4 SDB I have at the moment does (partially)
+   seem to believe that DWARF register number 11 is associated with
+   the x86 register %st(0), but that's about all.  Higher DWARF
+   register numbers don't seem to be associated with anything in
+   particular, and even for DWARF regno 11, SDB only seems to under-
+   stand that it should say that a variable lives in %st(0) (when
+   asked via an `=' command) if we said it was in DWARF regno 11,
+   but SDB still prints garbage when asked for the value of the
+   variable in question (via a `/' command).
+   (Also note that the labels SDB prints for various FP stack regs
+   when doing an `x' command are all wrong.)
+   Note that these problems generally don't affect the native SVR4
+   C compiler because it doesn't allow the use of -O with -g and
+   because when it is *not* optimizing, it allocates a memory
+   location for each floating-point variable, and the memory
+   location is what gets described in the DWARF AT_location
+   attribute for the variable in question.
+   Regardless of the severe mental illness of the x86/svr4 SDB, we
+   do something sensible here and we use the following DWARF
+   register numbers.  Note that these are all stack-top-relative
+   numbers.
+	11 for %st(0) (gnu regno = 8)
+	12 for %st(1) (gnu regno = 9)
+	13 for %st(2) (gnu regno = 10)
+	14 for %st(3) (gnu regno = 11)
+	15 for %st(4) (gnu regno = 12)
+	16 for %st(5) (gnu regno = 13)
+	17 for %st(6) (gnu regno = 14)
+	18 for %st(7) (gnu regno = 15)
+*/
+#undef DBX_REGISTER_NUMBER
+#define DBX_REGISTER_NUMBER(n) \
+((n) == 0 ? 0 \
+ : (n) == 1 ? 2 \
+ : (n) == 2 ? 1 \
+ : (n) == 3 ? 3 \
+ : (n) == 4 ? 6 \
+ : (n) == 5 ? 7 \
+ : (n) == 6 ? 5 \
+ : (n) == 7 ? 4 \
+ : ((n) >= FIRST_STACK_REG && (n) <= LAST_STACK_REG) ? (n)+3 \
+ : (-1))
+
+/* Output assembler code to FILE to increment profiler label # LABELNO
+   for profiling a function entry.  */
+
+#undef FUNCTION_PROFILER
+#define FUNCTION_PROFILER(FILE, LABELNO)  \
+{									\
+  if (flag_pic)								\
+    {									\
+      fprintf (FILE, "\tleal %sP%d@GOTOFF(%%ebx),%%edx\n",		\
+	       LPREFIX, (LABELNO));					\
+      fprintf (FILE, "\tcall *mcount@GOT(%%ebx)\n");			\
+    }									\
+  else									\
+    {									\
+      fprintf (FILE, "\tmovl $%sP%d,%%edx\n", LPREFIX, (LABELNO));	\
+      fprintf (FILE, "\tcall mcount\n");				\
+    }									\
+}
+
+#undef SIZE_TYPE
+#define SIZE_TYPE "unsigned int"
+ 
+#undef PTRDIFF_TYPE
+#define PTRDIFF_TYPE "int"
+  
+#undef WCHAR_TYPE
+#define WCHAR_TYPE "long int"
+   
+#undef WCHAR_TYPE_SIZE
+#define WCHAR_TYPE_SIZE BITS_PER_WORD
+    
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES  "-Di386 -D__embedded__ \
+   -Asystem(rtems) -Acpu(i386) -Amachine(i386)"
+
+/* Get perform_* macros to build libgcc.a.  */
+#include "i386/perform.h"
+
+/* A C statement (sans semicolon) to output to the stdio stream
+   FILE the assembler definition of uninitialized global DECL named
+   NAME whose size is SIZE bytes and alignment is ALIGN bytes.
+   Try to use asm_output_aligned_bss to implement this macro.  */
+
+#define ASM_OUTPUT_ALIGNED_BSS(FILE, DECL, NAME, SIZE, ALIGN) \
+  asm_output_aligned_bss (FILE, DECL, NAME, SIZE, ALIGN)
+
+#undef CPP_SPEC
+#define CPP_SPEC "%(cpp_cpu) %{msoft-float:-D_SOFT_FLOAT}"
+
+#undef CC1_SPEC
+#define CC1_SPEC "%(cc1_cpu)"
+
+#undef STARTFILE_SPEC
+#define STARTFILE_SPEC "crt0.o%s crti.o%s crtbegin.o%s"
+
+#undef ENDFILE_SPEC
+#define ENDFILE_SPEC   "crtend.o%s crtn.o%s"
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/rtems.h gcc-2.95.3/gcc/config/i386/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/rtems.h	Wed Dec 16 15:03:56 1998
+++ gcc-2.95.3/gcc/config/i386/rtems.h	Fri Jun 22 10:49:58 2001
@@ -27,8 +27,16 @@
 #define CPP_PREDEFINES "-Di386 -Drtems -D__rtems__ \
    -Asystem(rtems) -Acpu(i386) -Amachine(i386)"
 
+#undef CPP_SPEC
+#define CPP_SPEC "%(cpp_cpu) %{msoft-float:-D_SOFT_FLOAT}"
+
+#undef CC1_SPEC
+#define CC1_SPEC "%(cc1_cpu)"
+
 /* Generate calls to memcpy, memcmp and memset.  */
 #ifndef TARGET_MEM_FUNCTIONS
 #define TARGET_MEM_FUNCTIONS
 #endif
 
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/rtemself.h gcc-2.95.3/gcc/config/i386/rtemself.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/rtemself.h	Wed Dec 16 15:03:57 1998
+++ gcc-2.95.3/gcc/config/i386/rtemself.h	Fri Jun 22 10:49:58 2001
@@ -162,8 +162,17 @@
 #define ASM_OUTPUT_ALIGNED_BSS(FILE, DECL, NAME, SIZE, ALIGN) \
   asm_output_aligned_bss (FILE, DECL, NAME, SIZE, ALIGN)
 
+#undef CPP_SPEC
+#define CPP_SPEC "%(cpp_cpu) %{msoft-float:-D_SOFT_FLOAT}"
+
+#undef CC1_SPEC
+#define CC1_SPEC "%(cc1_cpu)"
+
 #undef STARTFILE_SPEC
-#define STARTFILE_SPEC  "crt0.o%s"
+#define STARTFILE_SPEC "crt0.o%s crti.o%s crtbegin.o%s"
 
 #undef ENDFILE_SPEC
-     
+#define ENDFILE_SPEC   "crtend.o%s crtn.o%s"
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h> 
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/t-i386bare gcc-2.95.3/gcc/config/i386/t-i386bare
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/t-i386bare	Wed Dec 16 15:04:30 1998
+++ gcc-2.95.3/gcc/config/i386/t-i386bare	Fri Jun 22 10:49:58 2001
@@ -1,3 +1,35 @@
 # The i386 md has all of these taken care of, according to sef.
 LIBGCC1 =
 CROSS_LIBGCC1 =
+
+# We want fine grained libraries, so use the new code to build the
+# floating point emulation libraries.
+FPBIT = fp-bit.c
+DPBIT = dp-bit.c
+
+LIB2FUNCS_EXTRA = xp-bit.c
+
+dp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#ifdef __LITTLE_ENDIAN__' > dp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >>dp-bit.c
+	echo '#endif'           >> dp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> dp-bit.c
+
+fp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define FLOAT' > fp-bit.c
+	echo '#ifdef __LITTLE_ENDIAN__' >> fp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >>fp-bit.c
+	echo '#endif'           >> fp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> fp-bit.c
+
+xp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define EXTENDED_FLOAT_STUBS' > xp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> xp-bit.c
+
+MULTILIB_OPTIONS = msoft-float
+MULTILIB_DIRNAMES = soft-float
+
+EXTRA_MULTILIB_PARTS = crtbegin.o crtend.o
+
+LIBGCC = stmp-multilib
+INSTALL_LIBGCC = install-multilib
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/t-rtems-i386 gcc-2.95.3/gcc/config/i386/t-rtems-i386
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i386/t-rtems-i386	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/i386/t-rtems-i386	Fri Jun 22 14:00:22 2001
@@ -0,0 +1,56 @@
+#
+# This file was based on t-sol2 - x68 Solaris implementation. Actually,
+# the source code to create crti.o anf crtn.o are exactly the same 
+# as the ones for Solaris. Later, we might want to have a RTEMS's 
+# version of these files.
+#
+
+LIBGCC1 = 
+CROSS_LIBGCC1 = 
+
+crti.o: $(srcdir)/config/i386/sol2-ci.asm $(GCC_PASSES)
+	sed -e '/^!/d' <$(srcdir)/config/i386/sol2-ci.asm >crti.s
+	$(GCC_FOR_TARGET) -c -o crti.o crti.s
+crtn.o: $(srcdir)/config/i386/sol2-cn.asm $(GCC_PASSES)
+	sed -e '/^!/d' <$(srcdir)/config/i386/sol2-cn.asm >crtn.s
+	$(GCC_FOR_TARGET) -c -o crtn.o crtn.s
+
+# We want fine grained libraries, so use the new code to build the
+# floating point emulation libraries.
+FPBIT = fp-bit.c
+DPBIT = dp-bit.c
+
+LIB2FUNCS_EXTRA = xp-bit.c
+
+dp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#ifdef __LITTLE_ENDIAN__' > dp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >>dp-bit.c
+	echo '#endif'           >> dp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> dp-bit.c
+
+fp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define FLOAT' > fp-bit.c
+	echo '#ifdef __LITTLE_ENDIAN__' >> fp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >>fp-bit.c
+	echo '#endif'           >> fp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> fp-bit.c
+
+xp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define EXTENDED_FLOAT_STUBS' > xp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> xp-bit.c
+
+MULTILIB_OPTIONS = m486/mpentium/mpentiumpro/mcpu=k6 msoft-float \
+mno-fp-ret-in-387
+MULTILIB_DIRNAMES= m486 mpentium mpentiumpro k6 soft-float nofp
+MULTILIB_MATCHES = msoft-float=mno-m80387
+MULTILIB_EXCEPTIONS = \
+mno-fp-ret-in-387 \
+m486/*mno-fp-ret-in-387* \
+mpentium/*msoft-float* mpentium/*mno-fp-ret-in-387* \
+mpentiumpro/*msoft-float* mpentiumpro/*mno-fp-ret-in-387* \
+mcpu=k6/*msoft-float* mcpu=k6/*mno-fp-ret-in-387*
+
+EXTRA_MULTILIB_PARTS = crtbegin.o crtend.o
+
+LIBGCC = stmp-multilib
+INSTALL_LIBGCC = install-multilib
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i960/i960.h gcc-2.95.3/gcc/config/i960/i960.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i960/i960.h	Wed Apr  7 18:03:00 1999
+++ gcc-2.95.3/gcc/config/i960/i960.h	Fri Jun 22 10:49:58 2001
@@ -38,6 +38,7 @@
 			%{mmc:-D__i960MC}\
 			%{mca:-D__i960CA}%{mcc:-D__i960CC}\
 			%{mcf:-D__i960CF}}\
+        %{msoft-float: -D_SOFT_FLOAT}\
 	%{mka:-D__i960KA__ -D__i960_KA__}\
 	%{mkb:-D__i960KB__ -D__i960_KB__}\
 	%{msa:-D__i960SA__ -D__i960_SA__}\
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i960/rtems.h gcc-2.95.3/gcc/config/i960/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/i960/rtems.h	Wed Dec 16 15:05:53 1998
+++ gcc-2.95.3/gcc/config/i960/rtems.h	Fri Jun 22 10:49:58 2001
@@ -31,3 +31,6 @@
 #ifndef TARGET_MEM_FUNCTIONS
 #define TARGET_MEM_FUNCTIONS
 #endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/crti.s gcc-2.95.3/gcc/config/m68k/crti.s
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/crti.s	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/m68k/crti.s	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,47 @@
+/* Specialized code needed to support construction and destruction of
+   file-scope objects in C++ and Java code, and to support exception handling.
+   Copyright (C) 1999 Free Software Foundation, Inc.
+   Contributed by Charles-Antoine Gauthier (charles.gauthier@iit.nrc.ca).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* As a special exception, if you link this library with files
+   compiled with GCC to produce an executable, this does not cause
+   the resulting executable to be covered by the GNU General Public License.
+   This exception does not however invalidate any other reasons why
+   the executable file might be covered by the GNU General Public License.  */
+
+/*
+ * This file just supplies function prologues for the .init and .fini
+ * sections.  It is linked in before crtbegin.o.
+ */
+
+	.file   "crti.o"
+	.ident  "GNU C crti.o"
+
+	.section .init
+	.globl  _init
+	.type   _init,@function
+_init:
+	linkw %fp,#0
+
+	.section .fini
+	.globl  _fini
+	.type   _fini,@function
+_fini:
+	linkw %fp,#0
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/crtn.s gcc-2.95.3/gcc/config/m68k/crtn.s
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/crtn.s	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/m68k/crtn.s	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,43 @@
+/* Specialized code needed to support construction and destruction of
+   file-scope objects in C++ and Java code, and to support exception handling.
+   Copyright (C) 1999 Free Software Foundation, Inc.
+   Contributed by Charles-Antoine Gauthier (charles.gauthier@iit.nrc.ca).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* As a special exception, if you link this library with files
+   compiled with GCC to produce an executable, this does not cause
+   the resulting executable to be covered by the GNU General Public License.
+   This exception does not however invalidate any other reasons why
+   the executable file might be covered by the GNU General Public License.  */
+
+/*
+ * This file supplies function epilogues for the .init and .fini sections.
+ * It is linked in after all other files.
+ */
+
+	.file   "crtn.o"
+	.ident  "GNU C crtn.o"
+
+	.section .init
+	unlk %fp
+	rts
+
+	.section .fini
+	unlk %fp
+	rts
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/rtems.h gcc-2.95.3/gcc/config/m68k/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/rtems.h	Wed Dec 16 15:07:15 1998
+++ gcc-2.95.3/gcc/config/m68k/rtems.h	Fri Jun 22 10:49:58 2001
@@ -31,3 +31,6 @@
 #ifndef TARGET_MEM_FUNCTIONS
 #define TARGET_MEM_FUNCTIONS
 #endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/rtemself.h gcc-2.95.3/gcc/config/m68k/rtemself.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/rtemself.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/m68k/rtemself.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,68 @@
+/* Definitions for rtems targeting a Motorola m68k using elf.
+   Copyright (C) 1999, National Research Council of Canada.
+   Contributed by Charles-Antoine Gauthier (charles.gauthier@nrc.ca).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+
+#define MOTOROLA       /* Use Motorola syntax rather than MIT.  */
+
+#include "m68k/m68020-elf.h"
+
+/* Specify predefined symbols in preprocessor.  */
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-Dmc68000 -Drtems -D__rtems__ -D__ELF__ \
+   -Asystem(rtems) -Acpu(mc68000) -Acpu(m68k) -Amachine(m68k)"
+
+/* Generate calls to memcpy, memcmp and memset.  */
+#ifndef TARGET_MEM_FUNCTIONS
+#define TARGET_MEM_FUNCTIONS
+#endif
+
+/*
+ *  Each RTEMS BSP provides its own crt0 and linker script.  Unfortunately
+ *  this means that crt0 and the linker script are not available as
+ *  each tool is configured.  Without a crt0 and linker script, m68k ELF
+ *  targets do not successfully link "conftest.c" during the configuration
+ *  process.  RTEMS supplies a crt0.c that provides all the symbols required
+ *  to successfully link a program.  The resulting program will not run 
+ *  but this is enough to satisfy the autoconf macro AC_PROG_CC.
+ *  Override STARTFILE_SPEC to use the fake crt0.o supplied by rtems.
+ */
+#undef STARTFILE_SPEC
+#define STARTFILE_SPEC "crt0.o%s"
+
+/*
+ *  Redefine INIT_SECTION_ASM_OP and FINI_SECTION_ASM_OP. This is the easiest
+ *  way to process constructors, destructors, and the exception frame
+ *  information at startup.
+ */
+#undef INIT_SECTION_ASM_OP
+#define INIT_SECTION_ASM_OP    ".section\t.init"
+#undef FINI_SECTION_ASM_OP
+#define FINI_SECTION_ASM_OP    ".section\t.fini"
+
+#undef EH_FRAME_SECTION_ASM_OP
+#define EH_FRAME_SECTION_ASM_OP        ".section\t.eh_frame"
+
+/* Do I need this? */
+#undef INVOKE__main
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
